<?php

namespace WebsiteBundle\Controller\Admin;

use Bazookas\AdminBundle\Controller\Base\BaseAdminDashboardController;
use Bazookas\AdminBundle\PageBuilder\GenericPageBuilder;
use Symfony\Component\HttpFoundation\Request;
use WebsiteBundle\Security\Roles;

class HomeDashboardController extends BaseAdminDashboardController
{

  protected function hasAccess($action) {
    return $this->isGranted(Roles::ROLE_CMS_USER);
  }

  public function modifyDashboardBuilder(Request $request, GenericPageBuilder $builder) {
    $dashboardService = $this->get('WebsiteBundle.Services.HomeDashboardDataService');
    $elements = $dashboardService->getDashboardElements($this->getUser());

    $builder->setElements($elements);

    return $builder;
  }

}
