<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity
 * @ORM\HasLifecycleCallbacks
 */
class MoodAnswer extends BaseEntity {

  /**
   * @ORM\ManyToOne(targetEntity="MoodQuestion", inversedBy="answers")
   * @var MoodQuestion
   */
  private $question;

  /**
   * @ORM\Column(type="integer")
   * @var integer
   * @Assert\NotBlank
   */
  private $value;

  /**
   * @ORM\ManyToOne(targetEntity="Participant")
   * @var Participant
   */
  private $participant;

  /**
   * @ORM\ManyToOne(targetEntity="TestSession", inversedBy="moodAnswers")
   */
  private $session;

  public function getQuestion()
  {
    return $this->question;
  }

  public function setQuestion(MoodQuestion $question)
  {
    $this->question = $question;

    return $this;
  }

  public function getValue()
  {
    return $this->value;
  }

  public function setValue($value)
  {
    $this->value = $value;

    return $this;
  }

  public function getParticipant()
  {
    return $this->participant;
  }

  public function setParticipant(Participant $participant)
  {
    $this->participant = $participant;

    return $this;
  }

  public function getSession()
  {
    return $this->session;
  }

  public function setSession($session)
  {
    $this->session = $session;

    return $this;
  }

}
