<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use WebsiteBundle\Security\Roles;

/**
 * @ORM\Entity(repositoryClass="WebsiteBundle\Repository\QuoteRepository")
 * @ORM\HasLifecycleCallbacks
 */
class Quote extends BaseEntity {

  const TYPE_GENERIC = 'generic';
  const TYPE_MASTER = 'master';

  /**
   * @ORM\Column(type="text")
   * @var string
   */
  private $quote;

  /**
   * @ORM\Column(type="string")
   * @var string
   */
  private $type;

  /**
   * @return string
   */
  public function getQuote()
  {
    return $this->quote;
  }

  /**
   * @param string $quote
   * @return Quote
   */
  public function setQuote($quote)
  {
    $this->quote = $quote;

    return $this;
  }

  /**
   * @return string
   */
  public function getType()
  {
    return $this->type;
  }

  /**
   * @param string $type
   * @return Quote
   */
  public function setType($type)
  {
    $this->type = $type;

    return $this;
  }

  public function getRoleRequiredForView()
  {
    return Roles::ROLE_ADMIN_RESEARCHER;
  }

}
