<?php

namespace WebsiteBundle\Form\Site;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use WebsiteBundle\Entity\Participant;

class ResetPasswordForm extends AbstractType
{

  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('plainPassword', RepeatedType::class, [
        'label' => 'admin.entities.participant.fields.plainPassword',
        'type' => PasswordType::class,
        'options' => array('attr' => array('class' => 'password-field')),
        'required' => is_null($builder->getData()->getId()),
        'first_options'  => array('label' => 'admin.entities.participant.fields.plainPassword'),
        'second_options' => array('label' => 'admin.entities.participant.fields.plainPasswordRepeat')
      ])
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults([
      'data_class' => Participant::class,
      'translation_domain' => 'admin'
    ]);
  }
}
