<?php

namespace WebsiteBundle\Repository;

use Bazookas\CommonBundle\Repository\Base\BaseRepository;
use Doctrine\ORM\Query;
use WebsiteBundle\Entity\Experiment;
use WebsiteBundle\Entity\Participant;
use WebsiteBundle\Entity\PsychEducationPanel;

class PsychEducationRepository extends BaseRepository
{

  public function getEntityClass() {
    return PsychEducationPanel::class;
  }

  public function getPsychEducationPanels(Experiment $experiment, $returnType = Query::HYDRATE_ARRAY) {
    $qb = $this->createQueryBuilder('panel');
    $qb
      ->addSelect('panelResponses')
      ->leftJoin('panel.responses', 'panelResponses')

      ->andWhere($qb->expr()->eq('panel.experiment', ':experiment'))
      ->setParameter('experiment', $experiment)
      ->orderBy('panel.id', 'ASC')
    ;

    return $qb->getQuery()->getResult($returnType);
  }

  public function getPsychoFaqItems(Participant $participant) {
    $experiment = $participant->getExperiment();

    $qb = $this->createQueryBuilder('panel');
    $qb
      ->andWhere($qb->expr()->eq('panel.experiment', ':experiment'))
      ->andWhere($qb->expr()->eq('panel.type', ':panelType'))
      ->setParameters([
        'experiment' => $experiment,
        'panelType' => PsychEducationPanel::TYPE_TEXT
      ])
    ;

    return $qb->getQuery()->getArrayResult();
  }
}
