<?php

namespace WebsiteBundle\Repository;

use Bazookas\AdminBundle\Repository\Base\BaseRepository;
use WebsiteBundle\Entity\Participant;
use WebsiteBundle\Entity\UnlockedQuote;

class UnlockedQuoteRepository extends BaseRepository
{

  public function markAsViewed($unlockedId, Participant $participant) {
    $qb = $this->_em->createQueryBuilder();
    $qb
      ->update(UnlockedQuote::class, 'quote')
      ->set('quote.viewed', ':viewed')

      ->andWhere($qb->expr()->eq('quote.participant', ':participant'))
      ->andWhere($qb->expr()->eq('quote.id', ':id'))

      ->setParameters([
        'viewed' => true,
        'participant' => $participant,
        'id' => $unlockedId
      ])
    ;

    $qb->getQuery()->execute();
  }

}
