var bazookas = bazookas || {};

bazookas.reminder = (function () {
  var self = {},
    language,
    now;

  var selectedDay = null;
  var selectedTime = null;

  var $pickedHour = $('#reminder_nextSession_time_hour');
  var $pickedMin = $('#reminder_nextSession_time_minute');
  var $pickedDay = $('#reminder_nextSession_date_day');
  var $pickedMonth = $('#reminder_nextSession_date_month');
  var $pickedYear = $('#reminder_nextSession_date_year');

  var $submitButton = $('.js-submit-reminder');

  self.init = function (context) {
    $('#time-picker').clockpicker({
      autoclose: true
    });
    $('.day').on('click', selectDayClickHandler);
    $('#time-picker').on('change', dateTimeChangeHandler);
    $submitButton.on('click', submitFormClickHandler);
  };

  function selectDayClickHandler(e){
    var $selection = $(e.currentTarget);
    $('.day').removeClass('selected');
    $(e.currentTarget).addClass('selected');
    selectedDay = {
      day: $selection.data('day'),
      month: $selection.data('month'),
      year: $selection.data('year')
    };

    fillInHiddenForm();
  }

  function dateTimeChangeHandler(e){
    selectedTime = this.value;
    $('.timer__picker__value').text(selectedTime);
    fillInHiddenForm();
  }

  function submitFormClickHandler(){
    document.reminder.submit();
  }

  function fillInHiddenForm(){
    if(selectedDay){
      $pickedDay.val(selectedDay.day);
      $pickedMonth.val(selectedDay.month);
      $pickedYear.val(selectedDay.year);
    }

    if(selectedTime){
      var splitTime = selectedTime.split(':');
      $pickedHour.val(parseInt(splitTime[0]));
      $pickedMin.val(parseInt(splitTime[1]));
    }
  }
  return self;
})();

