<?php

namespace WebsiteBundle\Services\Export;

use Bazookas\ExportBundle\Services\Data\DefaultDataSelectorService;
use WebsiteBundle\Entity\Experiment;

class TestAnswerExportDataService extends DefaultDataSelectorService
{

  protected function createDataArray(array &$fields, array $data) {
    $dataArray = parent::createDataArray($fields, $data);

    if (!empty($data)) {
      //Get the experiment associated with these results
      $experimentId = $data[0]['experiment']['id'];
      $experimentRepo = $this->entityManager->getRepository(Experiment::class);
      $experiment = $experimentRepo->findOneById($experimentId);

      //add the extra columns
      $moodQuestions = $experiment->getMoodQuestions();
      $moodQuestionCount = count($moodQuestions);
      for($i = 0; $i < $moodQuestionCount; $i++) {
        $question = $moodQuestions[$i]->getQuestion();

        $fields[$question] = $question;
      }

      //Now add the mood answers as separate columns
      foreach($dataArray as $key => $rowData) {
        $answers = $data[$key]['moodAnswers'];

        if (!empty($answers)) {
          foreach($answers as $answer) {
            $rowData[] = $answer['value'];
          }
        }

        $dataArray[$key] = $rowData;
      }
    }

    return $dataArray;
  }
}
