<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;
use Bazookas\AdminBundle\AdminElements\Elements\Actions\MenuActions\MenuActionElement;

class MenuContainer extends BaseAdminElement
{
  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:menuContainer.html.twig',
      'isSubMenuContainer' => false
    ]);
  }

  /**
   * @param $route
   * @return bool
   */
  public function hasActiveChild($route) {
    foreach($this->children as $child) {
      if ($child instanceof MenuActionElement) {
        if ($route === $child->getRoute()) {
          return true;
        }
      }
    }

    return false;
  }

  /**
   * @return bool
   */
  public function isSubMenuContainer() {
    return $this->options['isSubMenuContainer'];
  }

  /**
   * @param bool $bool
   * @return $this
   */
  public function setIsSubMenuContainer($bool) {
    $this->options['isSubMenuContainer'] = $bool;
    return $this;
  }
}
