<?php

namespace Bazookas\AdminBundle\AdminElements\Interfaces;

interface AdminElementInterface {

  public function __construct($children = [], $options = []);

  public function getOptions();

  /**
   * @param array $options
   * @return $this
   */
  public function setOptions(array $options);

  /**
   * @return AdminElementInterface[]
   */
  public function getChildren();

  /**
   * @param AdminElementInterface[] $children
   * @return $this
   */
  public function setChildren(array $children);

  /**
   * @param AdminElementInterface $child
   * @return $this
   */
  public function addChild(AdminElementInterface $child);

  /**
   * @param AdminElementInterface $child
   * @return $this
   */
  public function removeChild(AdminElementInterface $child);

  /**
   * @return string[]
   */
  public function getRoles();

  /**
   * @param string[] $roles
   * @return $this
   */
  public function setRoles(array $roles);

  /**
   * @return string
   */
  public function getTemplate();

  /**
   * @param string $template
   * @return $this
   */
  public function setTemplate($template);


  /**
   * @return string
   */
  public function getClass();

  /**
   * @return int
   */
  public function getUniqueId();

  /**
   * @return string
   */
  public function getLabel();

  /**
   * @return mixed
   */
  public function getValue();

  /**
   * @return string
   */
  public function getIconClass();

  /**
   * @return string
   */
  public function getNavName();

  /**
   * @return string
   */
  public function getColClass();
}
