<?php

namespace Bazookas\AdminBundle;

use Bazookas\AdminBundle\DependencyInjection\Compiler\OverrideServiceCompilerPass;
use Bazookas\AdminBundle\Filter\FilterField;
use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\HttpKernel\Bundle\Bundle;

//classes to compile
use Bazookas\AdminBundle\Controller\DashBoardController;
use Bazookas\AdminBundle\Controller\ListBaseController;
use Bazookas\AdminBundle\Controller\AdminController\CMSUserAdminController;
use Bazookas\AdminBundle\Controller\AdminController\CMSUserGroupAdminController;
use Bazookas\AdminBundle\Event\AdminListEvent;
use Bazookas\AdminBundle\EventListener\FOSUserResettingListener;
use Bazookas\AdminBundle\Twig\MenuExtension;
use Bazookas\AdminBundle\Twig\UtilExtension;
use Bazookas\AdminBundle\Util\ListAction;
use Bazookas\AdminBundle\Util\ListConfigurator;
use Bazookas\AdminBundle\Util\ListField;

class BazookasAdminBundle extends Bundle
{
  // Use FOSUserBundle as parent to allow overriding templates
  public function getParent()
  {
    return 'FOSUserBundle';
  }

  public function load(array $configs, ContainerBuilder $container)
  {
    $this->addClassesToCompile(array(
      DashBoardController::class,
      ListBaseController::class,
      CMSUserAdminController::class,
      CMSUserGroupAdminController::class,
      AdminListEvent::class,
      FOSUserResettingListener::class,
      MenuExtension::class,
      UtilExtension::class,
      ListAction::class,
      ListConfigurator::class,
      ListField::class,
      FilterField::class
    ));
  }
}
