<?php

namespace Bazookas\AdminBundle\Entity;

use Bazookas\CommonBundle\Security\Roles;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use FOS\UserBundle\Model\GroupInterface;
use Doctrine\Common\Collections\ArrayCollection;
use Bazookas\CommonBundle\Entity\Base\BaseEntity;

  /**
  * @ORM\Table(name="cms_user_group")
  * @ORM\Entity(repositoryClass="Bazookas\AdminBundle\Repository\CMSUserGroupRepository")
  */
class CMSUserGroup extends BaseEntity implements GroupInterface
{
  /**
   * @ORM\Column(type="string")
   **/
  protected $name;

  /**
   * @ORM\Column(type="array")
   **/
  protected $roles;

  public function __construct() {
    parent::__construct();
  }

  public function getName() {
    return $this->name;
  }

  public function setName($name) {
    $this->name = $name;
    return $this;
  }

  public function getRoles()
  {
    return $this->roles;
  }

  public function setRoles(array $roles) {
    $this->roles = $roles;
    return $this;
  }

  public function addRole($role)
  {
    if (empty($this->roles)) {
      $this->roles = array();
    }

    $roles = new ArrayCollection($this->roles);

    if (!$roles->contains($role)) {
      $roles->add($role);
    }

    $this->roles = $roles->toArray();
  }

  public function removeRole($role)
  {
    $roles = new ArrayCollection($this->roles);

    if ($roles->contains($role)) {
      $roles->removeElement($role);
    }

    $this->roles = $roles->toArray();
  }

  public function hasRole($checkRole) {
    foreach($this->roles as $role) {
      if ($role === $checkRole) {
        return true;
      }
    }

    return false;
  }

  /**
  * overwrite of BaseEntity method
  */
  public function getRoleRequiredForView() {
    return Roles::ROLE_ADD_GROUP;
  }
}
