<?php
namespace Bazookas\AdminBundle\Form\Extension;

use Symfony\Component\Form\AbstractTypeExtension;
use Symfony\Component\Form\Extension\Core\Type\TextType;

use Symfony\Component\Form\FormView;
use Symfony\Component\Form\FormInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class IconPickerExtension extends AbstractTypeExtension
{
  public function getExtendedType() {
    return TextType::class;
  }

  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver
      ->setDefined([
        'render_as_icon_picker'
      ])
    ;

  }

  /**
    * Pass the image URL to the view
    *
    * @param FormView $view
    * @param FormInterface $form
    * @param array $options
    */
   public function buildView(FormView $view, FormInterface $form, array $options)
   {
      if (isset($options['render_as_icon_picker'])) {
        $view->vars['renderAsIcon'] = $options['render_as_icon_picker'];
      }
   }
}
