<?php

namespace Bazookas\AdminBundle\PageBuilder\Interfaces;

use Bazookas\AdminBundle\AdminElements\Elements\Actions\Base\BaseActionElement;
use Bazookas\AdminBundle\AdminElements\Interfaces\AdminElementInterface;
use Doctrine\ORM\EntityManagerInterface;
use Symfony\Component\HttpFoundation\Request;

interface PageBuilderInterface
{
  /**
   * Set the entity for which we're building a page
   * @param string $entityClass
   * @return $this
   */
  public function setEntityClass($entityClass);

  /**
   * @param EntityManagerInterface $entityManager
   * @return $this
   */
  public function setEntityManager(EntityManagerInterface $entityManager);

  /**
   * @param AdminElementInterface[] $elements
   * @return $this
   */
  public function setElements(array $elements);

  /**
   * Build the page
   * @param Request $request
   */
  public function buildPage(Request $request);

  /**
   * @return array
   */
  public function getTemplateData();

  /**
   * @return AdminElementInterface[]
   */
  public function getElements();

  /**
   * Get the short class name of the entity
   * @return string
   */
  public function getEntityShortClassName();

  /**
   * Add a new action element
   * @param BaseActionElement $action
   * @return $this
   */
  public function addAction(BaseActionElement $action);

}
