<?php

namespace Bazookas\AdminBundle\Twig;

use Bazookas\CommonBundle\Entity\Interfaces\AccessControlInterface;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorageInterface;
use Symfony\Component\Security\Core\Authorization\AuthorizationChecker;

class AccessControlExtension extends \Twig_Extension
{
  private $auth;
  private $storage;

  public function __construct(AuthorizationChecker $auth, TokenStorageInterface $storage) {
    $this->auth = $auth;
    $this->storage = $storage;
  }

  public function getFilters()
  {
    return array(
      new \Twig_SimpleFilter('accessControlCheck', array($this, 'accessControlCheck')),
    );
  }

  public function accessControlCheck($entity, $action) {
    if ($entity instanceof AccessControlInterface) {

      $token = $this->storage->getToken();
      $user = $token->getUser();

      return $entity->performAccessCheck($this->auth, $user, $action);
    } else {
      throw new \Exception('This function can only be used with entity implementing \'Bazookas\CommonBundle\Entity\Interfaces\AccessControlInterface\'');
    }
  }

  public function getName()
  {
    return 'access_controle_extension';
  }
}
