<?php

namespace Bazookas\AdminBundle\Util;

use Symfony\Component\OptionsResolver\OptionsResolver;

class PageAction {

  private $path;

  private $label;

  private $class;

  private $attr;

  private $options;

  public function __construct($options = []) {
    $this->setOptions($options);
  }

  private function generateClassString() {
    $this->class = 'btn';

    if (!empty($this->options['color'])) {
      $this->class .= ' btn-' . $this->options['color'];
    }

    if (!empty($this->options['icon'])) {
      $this->class .= ' btn-labeled ' . $this->options['icon'];
    }

    if (!empty($this->options['class'])) {
      $this->class .= ' '. $this->options['class'];
    }
  }

  public function getPath()
  {
    return $this->path;
  }

  public function setPath($path)
  {
    $this->path = $path;

    return $this;
  }

  public function getLabel()
  {
    return $this->label;
  }

  public function setLabel($label)
  {
    $this->label = $label;

    return $this;
  }

  public function getClass()
  {
    return $this->class;
  }

  public function getAttr()
  {
    return $this->attr;
  }

  public function getOptions()
  {
    return $this->options;
  }

  public function setOptions($options)
  {
    $resolver = new OptionsResolver();
    $resolver->setDefaults(array(
      'path' => '',
      'label' => '',
      'color' => 'success',
      'icon' => null,
      'attr' => [],
      'class' => null
    ));

    $this->options = $resolver->resolve($options);

    $this->attr = $this->options['attr'];
    $this->path = $this->options['path'];
    $this->label = $this->options['label'];

    $this->generateClassString();

    return $this;
  }

  public function getRoute()
  {
    return $this->route;
  }

  public function setRoute($route)
  {
    $this->route = $route;

    return $this;
  }

}
