<?php

namespace Bazookas\APIFrameworkBundle\Controller\Admin;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Bazookas\AdminBundle\Controller\ListBaseController;
use Bazookas\AdminBundle\Util\ListConfigurator;
use APIBundle\Entity\AppSettings;
use Bazookas\APIFrameworkBundle\Form\AppSettingsAdminType;

class AppSettingsAdminController extends ListBaseController
{

  function __construct() {
    // make sure parent construct is called!
    parent::__construct();

    $this->config->entity = AppSettings::class;
    $this->config->entityName = 'admin.entities.appSettings.name';
    $this->config->orderBy = 'created';

    $this->config
      //TODO type is for future use!
//      ->addField('type', 'admin.entities.appSettings.fields.type')
      ->addField('key', 'admin.entities.appSettings.fields.key')
      ->addField('setting', 'admin.entities.appSettings.fields.setting')

      ->setForm(AppSettingsAdminType::class)
    ;

    //enable filtering
    $this->config
      ->setShowFilter(true)
      ->setMaintainFilterState(true)
      //TODO type is for future use!
//      ->addBasicTextFilter('type', 'admin.entities.appSettings.fields.type')
      ->addBasicTextFilter('key', 'admin.entities.appSettings.fields.key')
      ->addBasicTextFilter('setting', 'admin.entities.appSettings.fields.setting')
    ;
  }

  protected function checkAccess($_action, $_id) {
    // when returning false on any action, there is no real need to set these
    // these are only usefull for showing/hiding the buttons
    // $this->config->setAccess(self::ACTION_ADD, false);
    // $this->config->setAccess(self::ACTION_EDIT, false);
    // $this->config->setAccess(self::ACTION_REMOVE, false);
    return $this->isGranted('ROLE_SUPER_ADMIN');
  }

}
