<?php

namespace Bazookas\APIFrameworkBundle\Entity\Base;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Bazookas\CommonBundle\Entity\Interfaces\EntityDetailInterface;
use Bazookas\CommonBundle\Entity\Interfaces\LocalisedEntityInterface;
use Bazookas\CommonBundle\Entity\Traits\DetailTrait;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

class BaseAppCopyDetail extends BaseEntity implements EntityDetailInterface, LocalisedEntityInterface {
  use DetailTrait;

  /**
   * @ORM\Column(type="string")
   * @Assert\NotBlank()
   */
  protected $value;


  /**
   * @var BaseAppCopy
   * override this in extending class to add the relation
   */
  protected $detailParent;

  public function getValue()
  {
    return $this->value;
  }

  public function setValue($value)
  {
    $this->value = $value;
    return $this;
  }

}
