<?php

namespace Bazookas\APIFrameworkBundle\Entity\Base;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

class BaseAppSettings extends BaseEntity {
  const TYPE_STRING = 'string';
  const TYPE_PHP_SERIALIZED = 'serialized'; // serialized php object or array

  /**
   * NO! Don't add an id named "id", use key instead
   */
  protected $id;

  /**
   * @ORM\Column(type="string")
   * @var string
   */
  protected $type = self::TYPE_STRING;

  /**
   * An id without auto generated value
   * @ORM\Id
   * @ORM\Column(type="string", name="key_string")
   * @Assert\NotBlank
   */
  protected $key;

  /**
   * You can put serialized php objects in here
   * @ORM\Column(type="text")
   * @Assert\NotBlank
   */
  protected $setting;

  public function getType()
  {
    return $this->type;
  }

  public function setType($type)
  {
    $this->type = $type;
    return $this;
  }

  public function getKey()
  {
    return $this->key;
  }

  public function setKey($key)
  {
    $this->key = $key;
    return $this;
  }

  public function getSetting()
  {
    return $this->setting;
  }

  public function setSetting($setting)
  {
    $this->setting = $setting;
    return $this;
  }

  /**
   * @return mixed $key to make entity action buttons work
   */
  public function getId() {
    return $this->getKey();
  }

}
