<?php

namespace Bazookas\APIFrameworkBundle\Form;

use Bazookas\APIFrameworkBundle\Entity\Base\BaseAppSettings;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AppSettingsAdminType extends AbstractType
{
    /**
     * @param FormBuilderInterface $builder
     * @param array $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
      $data = $builder->getData();

      $builder
        ->add('key', null, [
          'label' => 'admin.entities.appSettings.fields.key',
          'disabled' => !is_null($data->getKey()),
        ])
        /**
         * serializer is not implemented yet, so no need to let user choose
         * when a serializer is made, we can go crazy and make some sort of JSON input here
         */
//        ->add('type', ChoiceType::class, [
//          'label' => 'admin.entities.appSettings.fields.type',
//          'choices' => [
//            'admin.entities.appSettings.enums.type.string' => BaseAppSettings::TYPE_STRING,
//            'admin.entities.appSettings.enums.type.php_serialized' => BaseAppSettings::TYPE_PHP_SERIALIZED,
//          ],
//          'choice_attr' => function($val) {
//            if ($val === BaseAppSettings::TYPE_PHP_SERIALIZED) {
//              return [
//                'disabled' => true,
//              ];
//            }
//            return [];
//          },
//        ])
        ->add('setting', null, [
          'label' => 'admin.entities.appSettings.fields.setting',
        ])
      ;
    }
    
    /**
     * @param OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
      $resolver->setDefaults(array(
        'data_class' => BaseAppSettings::class
      ));
    }
}
