<?php

namespace Bazookas\CommonBundle;

use Symfony\Component\HttpKernel\Bundle\Bundle;

//classes to compile
use Bazookas\CommonBundle\EventListeners\Exception\LoggableExceptionsListener;
use Bazookas\CommonBundle\Repository\Base\BaseRepository;
use Bazookas\CommonBundle\Services\Exception\Events\LoggableExceptionEvent;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Bazookas\CommonBundle\Services\Exception\ExceptionManager;
use Bazookas\AdminBundle\Services\FileUploader;
use Bazookas\CommonBundle\Twig\CommonExtensions;

class BazookasCommonBundle extends Bundle
{
  public function load(array $configs, ContainerBuilder $container)
  {
    $this->addClassesToCompile(array(
      LoggableExceptionsListener::class,
      BaseRepository::class,
      LoggableExceptionEvent::class,
      LoggableExceptionInterface::class,
      ExceptionManager::class,
      FileUploader::class,
      CommonExtensions::class,
    ));
  }

}
