<?php

namespace Bazookas\CommonBundle\Exception\Base;

use Bazookas\CommonBundle\Exception\Interfaces\BaseExceptionInterface;
use Exception;

class BaseException extends \RuntimeException implements BaseExceptionInterface {

//  protected $code; // defined by \Exception
  protected $message;
  protected $name;

  // Redefine the exception so message isn't optional
  public function __construct($message, $name = BaseExceptionMap::GENERAL_ERROR, Exception $previous = null) {
    $this->message = $message;
    $this->name = $name;
    parent::__construct($message, 0, $previous);
  }

  // custom string representation of object
  public function __toString() {
    return get_class($this) . ": {$this->message}\n in '".$this->getFile()."' at line ".$this->getLine().".";
  }

  public function setName($name) {
    $this->name = $name;
    return $this;
  }
  public function getName() {
    if (!empty($this->name)) {
      return $this->name;
    }
    $reflectionClass = new \ReflectionClass($this);
    return $reflectionClass->getShortName();
  }
}
