<?php

namespace Bazookas\CommonBundle\Repository\Base;

use Bazookas\CommonBundle\Entity\Interfaces\ResettablePasswordInterface;

abstract class BaseUserRepository extends BaseRepository
{

  public function forgotPassword(ResettablePasswordInterface $user) {
    $hash = md5(random_bytes(64));

    $user->setForgotPasswordHash($hash);

    $this->entityManager->persist($user);
    $this->entityManager->flush();

    return $user;
  }

  public function getUserByForgotPasswordHash($hash) {
    return $this->findOneBy(array('forgotPasswordHash' => $hash));
  }

}
