# Compile and create a package

## Command

`php bin/console project:deploy:build`

Located in `Bazookas\CommonBundle\Command\Deploy\BuildCommand`

## Included tasks

- updateAssetVersion
  - you will be asked to input a new asset version
  - this version will be written to config.yml file automatically
  - will warn you when yml indenting might change
- optimizeAutoloader
  - `composer dump-autoload --optimize --no-dev --classmap-authoritative`
  - optimizes autoloader and greatly improves performance
- assetsInstall
  - creates (relative) symlinks to assets of bundles
- gulpBuild
  - `gulp clean && gulp build`
  - compiles assets
- createPackage
  - will create ./build/build.tar.gz
  - files/directories included
    - app
    - src
    - vendor
    - web
    - .htaccess
    - .user.ini
    - bin
  - files/directories excluded (takes precedence over include)
    - app/config/parameters.yml
    - web/uploads/
  - upload this file to project root on server
  - use `tar -zxf build.tar.gz` to extract
  - optionally add `-v` for more verbose output (before `f` option)
