<?php
namespace Bazookas\CommonBundle\Services\Exception;

use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Bazookas\CommonBundle\Services\Exception\Events\LoggableExceptionEvent;

class ExceptionManager
{
  private $dispatcher;

  public function __construct(EventDispatcherInterface $dispatcher) {
    $this->dispatcher = $dispatcher;
  }

  public function throwException(LoggableExceptionInterface $exception) {
    if ($exception->isLoggable()) {
      $event = new LoggableExceptionEvent($exception);
      $this->dispatcher->dispatch(LoggableExceptionEvent::NAME, $event);
    }

    throw $exception;
  }

}
