<?php

namespace Bazookas\CommonBundle\Utility;

class Utility {

  public static function startsWith($haystack, $needle) {
    // search backwards starting from haystack length characters from the end
    return $needle === "" || strrpos($haystack, $needle, -strlen($haystack)) !== false;
  }

  public static function endsWith($haystack, $needle) {
    // search forward starting from end minus needle length characters
    return $needle === "" || (($temp = strlen($haystack) - strlen($needle)) >= 0 && strpos($haystack, $needle, $temp) !== false);
  }

  public static function generateRandomString($length = 16, $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ') {
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
  }

  public static function arrayFilterRecursive(array &$input, callable $callback) {
    foreach ($input as &$value) {
      if (is_array($value)) {
        $value = self::arrayFilterRecursive($value, $callback);
      }
    }

    return array_filter($input, $callback);
  }

  public static function isAssociative(array $array)
  {
    return count(array_filter(array_keys($array), 'is_string')) > 0;
  }

  public static function convertTimeToReadable($value) {
    $value = intval($value);

    if (!empty($value) && $value > 0) {
      $seconds = $value % 60;
      $minutes = floor($value / 60) % 60;
      $hours = floor($value / 3600) % 24;
      $days = floor($value / 86400);

      return [$days, $hours, $minutes, $seconds];
    } else {
      return $value;
    }
  }

}
