<?php

namespace Bazookas\CronBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Table
 * @ORM\Entity(
 *   repositoryClass="Bazookas\CronBundle\Repository\CronHistoryRepository"
 * )
 * @ORM\HasLifecycleCallbacks
 */
class CronHistory extends BaseEntity {

  /**
   * @ORM\ManyToOne(targetEntity="Cron", inversedBy="history")
   */
  private $cron;

  /**
   * @ORM\Column(type="datetime")
   */
  private $runStart;

  /**
   * @ORM\Column(type="datetime")
   */
  private $runEnd;

  /**
   * @ORM\Column(type="string")
   */
  private $runStatus;

  /**
   * @ORM\Column(type="text")
   */
  private $runOutput;

  // prevent columns from being inserted in database
  protected $created;
  protected $modified;

  public function getCron()
  {
    return $this->cron;
  }

  public function setCron(Cron $cron)
  {
    $this->cron = $cron;
    return $this;
  }

  public function getRunStart()
  {
    return $this->runStart;
  }

  public function setRunStart($runStart)
  {
    $this->runStart = $runStart;

    return $this;
  }

  public function getRunEnd()
  {
    return $this->runEnd;
  }

  public function setRunEnd($runEnd)
  {
    $this->runEnd = $runEnd;

    return $this;
  }

  public function getRunStatus()
  {
    return $this->runStatus;
  }

  public function setRunStatus($runStatus)
  {
    $this->runStatus = $runStatus;

    return $this;
  }

  public function getRunOutput()
  {
    return $this->runOutput;
  }

  public function setRunOutput($runOutput)
  {
    $this->runOutput = $runOutput;

    return $this;
  }

}
