<?php

namespace Bazookas\MediaBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Bazookas\MediaBundle\Entity\Base\BaseMedia;
use Bazookas\CommonBundle\Entity\Base\BaseEntity;

/**
* @ORM\Entity
* @ORM\HasLifecycleCallbacks
*/
class VideoProvider extends BaseEntity {

  /**
  * @ORM\Column(type="string")
  */
  private $provider;

  /**
  * @ORM\Column(type="text", nullable=true)
  */
  private $accessToken;

  /**
  * @ORM\Column(type="datetime", nullable=true)
  */
  private $expiry;

  public function getProvider() {
    return $this->provider;
  }

  public function setProvider($provider) {
    $this->provider = $provider;
    return $this;
  }

  public function getAccessToken() {
    return $this->accessToken;
  }

  public function setAccessToken($token) {
    $this->accessToken = $token;
    return $this;
  }

  public function getExpiry() {
    return $this->expiry;
  }

  public function setExpiry($expiry) {
    $this->expiry = $expiry;
    return $this;
  }

  public function getRoleRequiredForView() {
    return 'ROLE_MEDIA_ADMIN';
  }
}
