<?php

namespace Bazookas\MediaBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Bazookas\CommonBundle\Form\Type\LocaleType;
use Bazookas\MediaBundle\Form\Type\MediaFolderType;

class BaseMediaType extends AbstractType
{
  /**
  * @param FormBuilderInterface $builder
  * @param array $options
  */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('locale', LocaleType::class)
      ->add('title', TextType::class, array(
        'label' => 'media.entities.base.fields.title',
        'required' => true,
      ))
      ->add('description', TextareaType::class, array(
        'label' => 'media.entities.base.fields.description',
        'required' => false,
      ))
      ->add('mediaFolder', MediaFolderType::class)
    ;
  }

  /**
  * @param OptionsResolver $resolver
  */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'data_class' => 'Bazookas\MediaBundle\Entity\Base\BaseMedia',
      'inherit_data' => true
    ));
  }

}
